<?php

namespace SmartData;

class Anonymizer
{
    static function anonymizeSeries($series)
    {
        $sig_idx = [];
        $len = 0;
        foreach ($series['series'] as $key => $value)
            if (! isset($sig_idx[$value['signature']]))
                $sig_idx[$value['signature']] = $len++;
        //Process a single serie
        if (isset($series['series'][0]['signature']))
            $return['series'] = self::anonymizeSeriesBasedOnFirstRecord($series['series'], $sig_idx);;
        return $return;
    }

    static function anonymizeSeriesBasedOnFirstRecord($serie, $signature_idx)
    {
        $transformedSeries = [];
        foreach ($serie as $data) {
            $data['x'] -= $serie[0]['x'];
            $data['y'] -= $serie[0]['y'];
            $data['z'] -= $serie[0]['z'];

            //Anonymize Signature based on an index
            $data['signature'] = $signature_idx[$data['signature']] ?? -1;
            $transformedSeries[] = $data;
        }
        return $transformedSeries;
    }

    //For historical purposes
    static function anonymizeSeriesBasedOnFirstRecordOfSignature($serie, $signature_idx)
    {
        $transformedSeries = [];
        $initialRefs = [];

        foreach ($serie as &$data) {
            $sig = $data['signature'];
            if (!isset($initialRefs[$sig])) {
                $initialRefs[$sig] = [
                    'x' => $data['x'],
                    'y' => $data['y'],
                    'z' => $data['z']
                ];
            }
            extract($initialRefs[$sig]);

            //Normalize x,y,z based on the first x,y,z of the serie
            foreach (['x', 'y', 'z'] as $key)
                $data[$key] -= $$key;

            //Anonymize Signature 
            $data['signature'] = $signature_idx[$data['signature']] ?? -1;
            $transformedSeries[] = $data;
        }
        return $transformedSeries;
    }
}
