#!/usr/bin/php
<?php
namespace SmartData;
require_once( __DIR__ . '/../Config.php');
require_once( __DIR__ . '/../Backend.php');

$BATCH_SIZE = 300;
$file_name =  $argv[1];
$type = $argv[2];
$start_minute =  (int) $argv[3];

$dttm = 1590444000000000 + ($start_minute  * 60000000);
$unit = 2224437540;
$domain = 'aqtech';

$row = 0;

if ($type === "D") {
    $x = 240;
    $y = 240;
    $z = 240; 
} else  {
    $x = 230;
    $y = 230;
    $z = 230;
} //  else


if (($handle = fopen($file_name, "r")) !== FALSE) {
    $cred = new Credentials($domain, Config::config()::CASSANDRA_SUPERUSER, Config::config()::CASSANDRA_SUPERPASS);
    fgetcsv($handle,",");  //  discard first line (headers)
    $backend = new Backend_V1_1($cred, true);
    $batch = array();
    $series = array();
    for  ($s = 3; $s <= 11; $s++) {
        array_push($series, new Series(SmartData::STATIC_VERSION, $unit, $x, $y, $z, 0, 1590444000000000, 1590452400000000, $s));
        array_push($batch, array());
    } 
    $batch_count = 0;
    $inserts_count = 0;
    while (($data = fgetcsv($handle, ",")) !== FALSE) {
        $num = count($data);
        $row++;
        if ($type === "D") {
           $x = 240;
           $y = 240;
           $z = 240; 
        } else  {
           $x = 230;
           $y = 230;
           $z = 230;
        } //  else
        $dev = 3;
        for ($col = 0; $col < 8; $col++) {
	   $smartdata = new StaticSmartData($unit, $data[ $col ], 0, 0, $x, $y, $z , $dttm, $dev);
           $dev = $dev + 1;
           array_push($batch[$col], $smartdata);
        } // for
        $dttm = $dttm + 25;
        $batch_count++;
        if ($batch_count >= $BATCH_SIZE) {
            // send  batch  to cassandra
            $new_batch = array();
            $ok = TRUE;
            for ($i = 0; $i < 8; $i++) {
                if ($backend->insertBatch($series[$i], ...$batch[$i]) === FALSE) {
                    $ok = FALSE;
                }
                array_push($new_batch, array());
            }
            if ($ok === FALSE) {
                echo 'Insertion failed for batch insert number: ' . strval($inserts_count) . '\n';
            }
            $inserts_count++;
            unset($batch);
            $batch = $new_batch;
            $batch_count = 0;
        }
    } // while
}
?>
