import psycopg2
from datetime import timedelta, datetime
import struct, sys, os
from subprocess import Popen, PIPE, STDOUT

'''
"AQT"
-------------------------------
"SignalRecordsBlobs"
Id | SignalRegisterId | SignalSettingId | DateTime | Raw
-------------------------------
"SignalSettings"
Id | MonitoringElementId | SignalRecorderId | Name | Color | SampleFactor | SignalType | Unit
-------------------------------
"SignalRegisters"
Id | SignalRecorderId | StartDateTime | EndDateTime | IsSequentialRegister | SequentialNumberOfRegister | SystemSampleInterval
-------------------------------
"SignalRecorder"
Id |      Name      | SettingId 
----+----------------+-----------
  1 | Vibracao       |         1
  2 | Partida_Parada |         1
  1 | Vibracao       |         1
  2 | Partida_Parada |         1
(4 rows)
-------------------------------
test query (light version -- limiting time range and settingid)
select distinct("Blobs"."Id"), "Blobs"."DateTime", "Blobs"."Raw", "Settings"."SignalType", "Settings"."Unit", "Registers"."SystemSampleInterval"*"Settings"."SampleFactor" as "SamplingInterval" from "AQT"."SignalRecordsBlobs" as "Blobs" inner join "AQT"."SignalSettings" as "Settings" ON "Blobs"."SignalSettingId" = "Settings"."Id" join "AQT"."SignalRegisters" as "Registers" ON "Blobs"."SignalRegisterId" = "Registers"."Id" where "Blobs"."SignalSettingId" = 2 and "Blobs"."DateTime" between '2019-10-28 00:00:00' and '2019-12-28 00:00:00';
'''

def query_postgress():
    conn = psycopg2.connect(host='ssh.lisha.ufsc.br', port=5432, database='aqtech', user='postgres', password='KdeiBmtewpt')

    cur = conn.cursor()

    print("query running")

    # How to speed up by removing JOINs: (Slow speed up, the number of lines is usually small, blob size is the slowing factor)
    # (1) SystemSampleInterval seems to be a fixed value (at least it is for this dataset). The sampling interval can be defined by 5e-6 * "SignalSettings"."SampleFactor". (Remove last JOIN)
    # (2) SignalSettings is a small table, a query could be executed only once to get its content. Its information can be accessed locally after querying each one of the Blobs (time in RAM vs. SSH connection). (Remove First JOIN)

    cur.execute('SELECT DISTINCT("Id"), "Name", "Unit" FROM "AQT"."SignalSettings";')

    return cur.fetchall()

date_init  = datetime(2019, 11, 24) # '2019-11-25' - 1 day
#date_init  = datetime(2020, 5, 31) # '2019-11-25' - 1 day
date_end   = datetime(2020, 9, 26) # '2020-09-25' + 1 day
delta = timedelta(hours=24)

with open('units_report.csv', 'w') as file:
    temp = query_postgress()
    str_aux = "Id, Name, Unit\n"
    for line in temp:
        str_aux += str(line[0])+","+ str(line[1])+","+ str(line[2])+"\n"
    file.write(str_aux[:-1])
