#!/usr/bin/env python3
# -*- coding: utf-8 -*-
"""
Created on Sat Feb 05 14:57:13: 2022

@author: roberto
"""

#HOST = "dev.lisha.ufsc.br"
HOST = "iot.lisha.ufsc.br"
create_url ='https://'+HOST+'/api/create.php'
mv_put_url = "https://"+HOST+"/api/mv_put.php"
put_url = "https://"+HOST+"/api/put.php"
RATE = 50000

import json, os, sys, requests, random, base64, glob, time as sys_time
from datetime import datetime as dt
import glob
import numpy as np
import wavio

#To supress warning messages at every request to the server.
from requests.packages.urllib3.exceptions import InsecureRequestWarning
requests.packages.urllib3.disable_warnings(InsecureRequestWarning)

DEVS = [6, 1, 0, 2, 4, 3, 5, 7 ]
UNITS = [0xE4962924,0xE4962924,0xE4962924,0xE4962924,0xE4962924,0xE4962924,0xE4923924,0x02230000]

credentials = { 
    "domain": "mafaulda", 
    "username": "mafaulda",
    "password": "quino"
    }

#credentials = { 
#    "domain": "aqtech", 
#    "username": "aqtech",
#    "password": "jP#55Mh@"
#    }


series_normal= { "series" : {
    "version": "1.1",
    "unit": 0xE4962924,
    "x" : 0,
    "y" : 0,
    "z" : 0,
    "dev" : 0,
    "t0" : 0,
    "t1" : 9999,
    "type" : 'OLD',
    }, "credentials" : credentials
}

normal_sd = { 'smartdata' : [
          {
                'version' : '1.1',
                'unit'    : 0,
                'value'   : 0,
                'error'   : 0,
                'confidence' : 0,
                "x" : 0,
                "y" : 0,
                "z" : 0,
                't' : 1509391500000000,
                'type' : 'OLD',
                'dev' : 0 
            }
        ],
        "credentials" : credentials
    }

series_MIC = { "series" : {
    "version" : '1.1',
    "unit" : 0x02230000,    
    "x" : 0,
    "y" : 0,
    "z" : 0,
    "dev" : 0,
    "t0" : 0,
    "t1" : 9999,
    "workflow" : 0,
    }, "credentials" : credentials
}

flac_sd = { 'smartdata' : [
             {
                'version' : '1.1',
                'unit'    : 0x02230000,
                'value'   : 0,
                'error'   : 0,
                'confidence' : 0,
                "x" : 0,
                "y" : 0,
                "z" : 0,
                't' : 1509391500000000,
                'dev' : 0 
            }
        ],
        "credentials" : credentials
    }


series_mv = { "series" : {
    "version": "1.1",
    "unit": 0xE4923924,
    "x" : 0,
    "y" : 0,
    "z" : 0,
    "dev" : 0,
    "t0" : 0,
    "t1" : 9999,
    "type" : 'TTH',
    "period" : 20,
    "workflow" : 0,
    }, "credentials" : credentials
}

mvsd = {
    "MultiValueSmartData" : 
    {
        'version' : '1.1',
        "unit": 3232333333,
        "t0": 0,
        "r": 0,
        "x": 0,
        "y": 0,
        "z": 0,
        "uncertainty" : 0,
        "dev" : 1,
        "gateway" : -1,
        "type" : "TTH",
        "period": 50,
        "uncertainty": 0,
        "datapoints": [ ]
    },
   "credentials" : credentials
}

def send_wav(x, y, z, t0, t1, ts, wavdata):
    series_MIC['series']["x"] = x
    series_MIC['series']["y"] = y
    series_MIC['series']["z"] = z
    series_MIC['series']["t0"] = t0
    series_MIC['series']["t1"] = t1
    session = requests.Session()
    session.headers = {'Content-type' : 'application/json'}
    response = session.post(create_url, json.dumps(series_MIC), verify=False)
    print("CREATE WAV Series: ", response.status_code)
    if response.status_code != 204:
        print("Microphone series creation failed, aborting...")
        return False
    flac_sd["smartdata"][0]["t"] = ts
    flac_sd["smartdata"][0]["value"] = wavdata
    flac_sd["smartdata"][0]["x"] = x
    flac_sd["smartdata"][0]["y"] = y
    flac_sd["smartdata"][0]["z"] = z
    flac_sd["smartdata"][0]["dev"] = 7
    response = session.post(put_url, json.dumps(flac_sd), verify=False)
    if (response.status_code != 204):
        print("Microphone data insertion failed, aborting...")
        return False
    return True

def send_data(x, y, z, t0, t1, ts, unit, device, data):
    series_normal['series']['unit'] = unit;
    series_normal['series']['x'] = x
    series_normal['series']['y'] = y
    series_normal['series']['z'] = z
    series_normal['series']['t0'] = t0
    series_normal['series']['t1'] = t1
    session = requests.Session()
    session.headers = {'Content-type' : 'application/json'}
    response = session.post(create_url, json.dumps(series_normal), verify=False)
    print("CREATE Normal Series: ", response.status_code)
    if response.status_code != 204:
        print("Normal series creation failed, aborting...")
        return False
    normal_sd['smartdata'][0]['unit'] = unit
    normal_sd['smartdata'][0]['x'] = x
    normal_sd['smartdata'][0]['y'] = y
    normal_sd['smartdata'][0]['z'] = z
    normal_sd['smartdata'][0]['t'] = ts
    normal_sd['smartdata'][0]['dev'] = device
    normal_sd['smartdata'][0]['value'] = data
    response = session.post(put_url, json.dumps(normal_sd), verify=False)
    if (response.status_code != 204):
        print("Normal data insertion failed, aborting...")
        return False
    return True

def send_mv_data(x, y, z, t0, t1, ts, unit, period, device, data):
    series_mv['series']['unit'] = unit;
    series_mv['series']['x'] = x
    series_mv['series']['y'] = y
    series_mv['series']['z'] = z
    series_mv['series']['t0'] = t0
    series_mv['series']['t1'] = t1
    series_mv['series']['period'] = period
    session = requests.Session()
    session.headers = {'Content-type' : 'application/json'}
    response = session.post(create_url, json.dumps(series_mv), verify=False)
    print("CREATE MultiValue Series: ", response.status_code)
    if response.status_code != 204:
        print("MultiValue series creation failed, aborting...")
        return False
    mvsd['MultiValueSmartData']['unit'] = unit
    mvsd['MultiValueSmartData']['x'] = x
    mvsd['MultiValueSmartData']['y'] = y
    mvsd['MultiValueSmartData']['z'] = z
    mvsd['MultiValueSmartData']['t0'] = ts
    mvsd['MultiValueSmartData']['type'] = 'TTH'
    mvsd['MultiValueSmartData']['dev'] = device
    mvsd['MultiValueSmartData']['period'] = period
    vals = []
    for v in data:
        vals.append({'value': v})
    mvsd['MultiValueSmartData']['datapoints'] = vals
    response = session.post(mv_put_url, json.dumps(mvsd), verify=False)
    if (response.status_code != 204):
        print("MultiValue data insertion failed with code ", response.status_code," -> aborting...")
        return False
    return True

if __name__ == '__main__':
    if len(sys.argv) != 5 :
        print("usage: ", sys.argv[0], " X Y Z filename");
        sys.exit( 0 )
    X = sys.argv[1]
    Y = sys.argv[2]
    Z = sys.argv[3]
    fldr = sys.argv[4]
    arqs = glob.glob(fldr+"/*.csv")
    t0 = 1644235200000000
    t1 = 1644278399000000
    t = t0
    arqs.sort()
    cnt = 1;
    for arq in arqs:
        print(arq)
        freq = float ( arq[arq.rindex("/")+1:-4] )
        dados = np.genfromtxt(arq, delimiter=',')
        data = freq;
        send_data(X, Y, Z, t0, t1, t, 0xE4923924, 8, data)  # to register the current frequency (rotatiom)
        for k in range(7):
            x = dados[:,k]
            send_mv_data(X, Y, Z, t0, t1, t, UNITS[k], 20, DEVS[k], x)
        x = dados[:,7]
        wav_name = "/smartdata/tmp/audio_temp.wav"
        wavio.write(wav_name, x, RATE, sampwidth=3)
        ent = np.fromfile(wav_name, dtype='int8');
        binstr =  base64.b64encode(ent);
        aux = str(binstr)
        data = aux[2 : len(aux)-1]
        send_wav(X, Y, Z, t0, t1, t, data)
        t = t + 10000000
