#!/usr/bin/python3
import struct, sys, os, time
import csv

T0 = 1606820400000000
TF = T0 + 60 * 1000 * 1000

DEPLOYED = True

files = [   "10RPM_low_noise/gear_data_10RPM_low_noise",
            "10RPM_low_noise/pinion_data_10RPM_low_noise",
            "15RPM_low_noise/gear_data_15RPM_low_noise",
            "15RPM_low_noise/pinion_data_15RPM_low_noise",
            "20RPM_low_noise/gear_data_20RPM_low_noise",
            "20RPM_low_noise/pinion_data_20RPM_low_noise",
            "10RPM_medium_noise/gear_data_10RPM_medium_noise",
            "10RPM_medium_noise/pinion_data_10RPM_medium_noise",
            "15RPM_medium_noise/gear_data_15RPM_medium_noise",
            "15RPM_medium_noise/pinion_data_15RPM_medium_noise",
            "20RPM_medium_noise/gear_data_20RPM_medium_noise",
            "20RPM_medium_noise/pinion_data_20RPM_medium_noise"

]

unit = 0xE4962924
x = 0
y = 0
z = 0

if (DEPLOYED):
    # run importer at server
    for dev, f in enumerate(files):
        print (dev, f)
        os.system("./single-series-csv-import.php 'data-vibration-wagner/%s.csv' "%(f.split('/')[1]) +str(unit)+" "+str(x)+" "+str(y)+" "+str(z)+" "+str(dev)+" "+str(T0)+" "+str(TF)+" "+str(0)+" >> importer_php.log")
else:
    #preprocess CSV at local pc
    for dev, f in enumerate(files):
        print (dev, f)
        csv_str = ""
        with open(f+'.csv') as csvfile:
            data = csv.reader(csvfile, delimiter=',')
            count = 0
            for row in data:
                if (count == 0):
                    count += 1
                    continue
                csv_str += str(T0+int(float(row[1])*1000000))+ "," + row[2] + "\n"

        with open('data-vibration-wagner/'+f.split('/')[1]+'.csv', 'w') as file:
            file.write(csv_str[:-1]) # remove last \n
