#!/usr/bin/php
<?php
namespace SmartData;
require_once( __DIR__ . '/../Config.php');
require_once( __DIR__ . '/../Backend.php');

//error_reporting(0);

//require_once( __DIR__ . '/../SmartData.php');
//require_once( __DIR__ . '/../Config.php');
//require_once( __DIR__ . '/../Backend.php');
//use SmartData\{Series, Backend_V1_1, Credentials, Config};

function create_series($unit, $x, $y, $z, $dev, $t0, $tf) {
    $domain   = 'aqtech';
    $username = 'aqtech';
    $passwd   = 'jP#55Mh@';
    $cred = new Credentials($domain, $username, $passwd);
    $backend = new Backend_V1_1($cred, true);
    $series = new Series(SmartData::STATIC_VERSION, $unit, $x, $y, $z, 0, $t0, $tf, $dev);
    echo $series->toJson();
    if ($backend->create($series) == FALSE) {
        echo "Fail to create Series:";
        return -1;
    }
    return 0;
}

function insert_csv($filename, $unit, $x, $y, $z, $dev, $t0, $tf, $series_exists)
{
    if ($series_exists == 0) {
	$res = 1;
        echo "Creating Series";
        $res = create_series($unit, $x, $y, $z, $dev, $t0, $tf);
	if ($res == -1) {
            //echo "Fail to create series";
            return -1;
        }
    }
    if (($handle = fopen($filename, "r")) !== FALSE) {
        $BATCH_SIZE = 10000;

        $domain   = 'aqtech';
        $username = 'aqtech';
        $passwd   = 'jP#55Mh@';
        $cred = new Credentials($domain, $username, $passwd);
        $backend = new Backend_V1_1($cred, true);
        $series = new Series(SmartData::STATIC_VERSION, $unit, $x, $y, $z, 0, $t0, $tf, $dev);
        echo "\nBatch Series:";
        echo $series->toJson();
        $batch_count = 0;
        $inserts_count = 0;
        /*
        * No headers are expected
        * Expected format:
        * value, timestamp
        */
        $batch = array();
        echo "\nStart Batch:";
        while (($data = fgetcsv($handle, ",")) !== FALSE) {
            // number_format(value, 15); for 15 decimal places
	    if ($unit == 1) {  // Digital data, switch (0/1) 
	         if ($data[1] == 'False') {
                     $x = pack('C', (int) 0);
                     $value = base64_decode('AA==');
                 } else {
                     $x = pack('C', (int) 1);
                     $value = base64_decode('AQ=='); 
		 }
            } else {
                 $value = (double)($data[1]);
            }
            $smartdata = new StaticSmartData($unit, $value, 0, 0, $x, $y, $z , (int)$data[0], $dev);
            //echo $smartdata->toJson();
            array_push($batch, $smartdata);
            $batch_count++;
            if ($batch_count >= $BATCH_SIZE) {
                // send  batch  to cassandra
                $new_batch = array();
                $ok = TRUE;
                if ($backend->insertBatch($series, ...$batch) === FALSE) {
                    $ok = FALSE;
                }
                if ($ok === FALSE) {
                    echo "\n Insertion failed for batch insert number: " . strval($inserts_count) . "\n";
                    // Uncomment line below to stop insertion in case of insertion fail
                    return -2;
                }
                $inserts_count++;
                unset($batch);
                $batch = $new_batch;
                $batch_count = 0;
            }
        } // while
	if ($batch_count > 0) {
            $ok = TRUE;
            if ($backend->insertBatch($series, ...$batch) === FALSE) {
                $ok = FALSE;
            }
            if ($ok === FALSE) {
                echo "\n Insertion failed for batch insert number: " . strval($inserts_count) . "\n";
                // Uncomment line below to stop insertion in case of insertion fail
                return -2;
            }
	}
        echo "\nEnd Batch OK";
        return 0;
    } else {
        return -3;
    }
}

//echo insert_csv("to_insert.csv", 0, 0, 0, 0, 0, 0, 0, 1);
//echo insert_csv($argv[1], $argv[2], 0, 0, 0, 0, 0, 0, 1);

echo var_dump($argv);
$filename = $argv[1];
$unit = (int)$argv[2];
$x = (int)$argv[3];
$y = (int)$argv[4];
$z = (int)$argv[5];
$dev = (int)$argv[6];
$t0 = (int)$argv[7];
$tf = (int)$argv[8];
$series_e = (int)$argv[9];

//echo "unit = " . strval($unit) . "\n";
//echo "x = " . strval($x) . "\n";
//echo "y = " . strval($y) . "\n";
//echo "z = " . strval($z) . "\n";
//echo "dev = " . strval($dev) . "\n";
//echo "t0 = " . strval($t0) . "\n";
//echo "tf = " . strval($tf) . "\n";
//echo "series_e = " . strval($series_e) . "\n";

echo insert_csv($filename, $unit, $x, $y, $z, $dev, $t0, $tf, $series_e);
echo "\n"
?>
