#!/usr/bin/env python3
# -*- coding: utf-8 -*-

HOST = "iot.lisha.ufsc.br"
create_url ='https://'+HOST+'/api/create.php'
put_url = "https://"+HOST+"/api/put.php"
get_url = "https://"+HOST+"/api/get.php"

import json, os, requests, random, base64, glob, time as sys_time
from datetime import datetime
from datetime import timedelta
import numpy as np
import wavio

#To supress warning messages at every request to the server.
from requests.packages.urllib3.exceptions import InsecureRequestWarning
requests.packages.urllib3.disable_warnings(InsecureRequestWarning)

X = 502732700
Y = -389317100
Z = -49815500
RATE = 20000

credentials = { 
    "domain": "aqtech", 
    "username": "aqtech",
    "password": "jP#55Mh@"
    }


flac_series = { 'series' : {
                'version' : '1.1',
    	        'unit' : 0x02230000,
    	        'x' : X,
    	        'y' : Y,
    	        'z' : Z,
    	        'r' : 0,
                't0' : 1509328800000000,
                't1' : 1609470000000000,
                'workflow' : 0
             },
            "credentials" : credentials
}

flac_sd = {
        'smartdata' : 
        [
            {
                'version' : '1.1',
                'unit'    : 0x02230000,
                'value'   : 0,
                'error'   : 0,
                'confidence' : 0,
                "x" : X,
                "y" : Y,
                "z" : Z,
                't' : 1509391500000000,
                'dev' : 99991581 
            }
        ],
        "credentials" : credentials
    }
    

def send_to_iot( filename, t0, t1 ):
    ent = np.fromfile(filename, dtype='int8');
    binstr =  base64.b64encode(ent);
    aux = str(binstr)
    data = aux[2 : len(aux)-1]
    print("Tamanho = ", len(ent)," T0: ", t0, " T1: ", t1)
    random.seed();
    time = t0
    start_time = sys_time.time()
    session = requests.Session()
    session.headers = {'Content-type' : 'application/json'}
    flac_series['series']['t0'] = t0
    flac_series['series']['t1'] = t1
    response = session.post(create_url, json.dumps(flac_series), verify=False)
    flac_sd['smartdata'][0]['t'] = time
    flac_sd['smartdata'][0]['value'] = data
    response = session.post(put_url, json.dumps(flac_sd), verify=False)
    duration = sys_time.time() - start_time;
    rc = response.status_code
    print("put:", rc)
    return rc
    
if __name__ == '__main__':
    arqs = glob.glob('/smartdata/wavs/mic_502732700_*.wav')
    for arq in arqs:
        print(arq)
        ts = int( arq[-20:-4] )
        print(ts)
        fdest = arq.replace("/wavs/","/wavs/ENC13/",1)
        dt = datetime.fromtimestamp( ts / 1000000.0)
        hora = dt.strftime("%Y_%m_%d_%H_%M_%S")
        aux = fdest[0:-20] + hora + ".wav"
        aux = aux.replace("_502732700_","_",1)
        print(aux)
        dt = dt + timedelta(seconds=4)
        _t0 = ts;
        _t1 = int(dt.timestamp() * 1000000);
        rc = send_to_iot( arq, _t0, _t1 )
        if (rc == 204):
           os.rename(arq, aux)
