<?php

require_once 'api/setup.php';
require_once 'api/routes.php';


use PHPUnit\Framework\TestCase;
use Slim\Psr7\Factory\ServerRequestFactory;

class BaseTest extends TestCase
{
    protected $app;

    public function setUp(): void
    {
        $this->app = setupRoutes(setupSlim());
    }

    protected function _createRequest($method, $url, $body = null) {
        $request = (new ServerRequestFactory())->createServerRequest($method, $url)->withHeader('Content-Type', 'application/json');
        if ($body) {
            $request->getBody()->write(json_encode($body));
        }
        return $request;
    }
    
}
