#!/bin/bash 
MRP=$MYSQL_ROOT_PASSWORD

# Initialize variable
db_command_path=""

# Check for mariadb command
if command -v mariadb &> /dev/null
then
    db_command_path=$(command -v mariadb)
elif command -v mysql &> /dev/null
then
    # Check for mysql command
    db_command_path=$(command -v mysql)
else
    echo "Neither mariadb nor mysql command found."
    exit 1
fi

echo "CREATE USER IF NOT EXISTS 'smartdata_admin' IDENTIFIED BY '$MYSQL_PASSWORD';"	| $db_command_path -u root --password=$MRP
echo "CREATE USER IF NOT EXISTS 'smartdata' IDENTIFIED BY '$MYSQL_PASSWORD';"	 	| $db_command_path -u root --password=$MRP
echo "CREATE USER IF NOT EXISTS 'tutorial' IDENTIFIED BY '$MYSQL_PASSWORD';" 		| $db_command_path -u root --password=$MRP

echo "GRANT ALL PRIVILEGES ON *.* TO 'smartdata_admin';" 				| $db_command_path -u root --password=$MRP
echo "GRANT ALL PRIVILEGES ON *.* TO 'smartdata';" 					| $db_command_path -u root --password=$MRP
echo "GRANT ALL PRIVILEGES ON *.* TO 'tutorial';"				    	| $db_command_path -u root --password=$MRP
