import {QueryCtrl} from 'app/plugins/sdk';
import './css/query-editor.css!'

export class SmartDataDSQueryCtrl extends QueryCtrl {

    constructor($scope, $injector)  {
        super($scope, $injector);

        this.scope = $scope;

        this.target.version             = this.target.version || '1.1';
        this.target.unit                = this.target.unit || '';
        this.target.x                   = this.target.x    || '';
        this.target.y                   = this.target.y    || '';
        this.target.z                   = this.target.z    || '';
        this.target.r                   = this.target.r    || '';
        this.target.dev                 = this.target.dev  || '0';
        //this.target.t0                = this.target.t0   || '';
        //this.target.t1                = this.target.t1   || '';
        this.target.domain              = this.target.domain || 'public';
        this.target.username            = this.target.username || '';
        this.target.password            = this.target.password || '';
        this.target.type                = this.target.type || '';
        this.target.ttype               = this.target.ttype || 'OLD';  // ttype stands for "trigger type": timed or event
        this.target.speriod             = this.target.speriod || '0';  // speriod stands for "series period"
        this.target.signature           = this.target.signature || '';
        this.target.aggregator          = this.target.aggregator || '';
        this.target.aggregatorRange     = this.target.aggregatorRange || '';
        this.target.aggregatorParameter = this.target.aggregatorParameter || '';
        this.target.aggregatorOffset     = this.target.aggregatorOffset || '';
        this.target.aggregatorSpacing   = this.target.aggregatorSpacing || '';
        // this.target.aggregatorExtra     = this.target.aggregatorExtra || '';
        // this.target.aggregatorDrift     = this.target.aggregatorDrift || '';
        // this.target.aggregatorStuck     = this.target.aggregatorStuck || '';
        // this.target.aggregatorBias      = this.target.aggregatorBias || '';
        // this.target.aggregatorGain      = this.target.aggregatorGain || '';
        this.target.workflow            = this.target.workflow || '0';
        //add here the json Aggregator
        if (!this.target.aliasMode) {
            this.target.aliasMode = 'default';
            this.target.alias =  this.datasource.getDefaultAlias(this.target);
        }

        //this.target.target = this.target.target || 'select metric';
        //this.target.type = this.target.type || 'timeseries';
    }

    getOptions(query) {
        return this.datasource.metricFindQuery(query || '');
    }

    /*  toggleEditorMode() {
    this.target.rawQuery = !this.target.rawQuery;
    }*/

    onChangeInternal() {
        this.targetBlur();
        this.panelCtrl.refresh(); // Asks the panel to refresh data.
    }

    getUnits() {
        return this.datasource.getUnits(this.target);
    }

    //getAggregators() {
    //    return this.datasource.getAggregators(this.target);
    //}

    targetBlur() {
        //this.target.errors = validateTarget(this.target);
        if (this.target.aliasMode === 'default') {
            this.target.alias = this.datasource.getDefaultAlias(this.target);
        }
        if (!_.isEqual(this.oldTarget, this.target) && _.isEmpty(this.target.errors)) {
            this.oldTarget = angular.copy(this.target);
            this.panelCtrl.refresh();
        }
    };
}

SmartDataDSQueryCtrl.templateUrl = 'partials/query.editor.html';
