from common.PlatformManagement import PlatformManagement
from common.SmartdataClient import SmartdataClient
import time

# Initializing Test Environment
service = PlatformManagement()
domain = 'smartdatatest' + str(int(time.time()))
assert service.createDomain(domain), 'Domain was not created'
cert = service.generateCredentials(domain)
assert cert['serial'], 'Cert was not created'
with open("/tmp/client.key", "w", encoding="utf-8") as file:
    file.write(str(cert['key']))
with open("/tmp/client.crt", "w", encoding="utf-8") as file:
    file.write(str(cert['pem']))

unit = 0x84925924
client = SmartdataClient()

# cria series
serie = client.createSeries(unit, 0, 0, 0, 100, 0, 10, 0, 'sig')
assert serie, "SERIE deveria ter retornado True"
# get sem retorno
get = client.get(unit, 1, 1, 1, 10, 0, 10, 0, 'sig')
assert get['series'] == [], f"GET deveria ter retornado vazio, mas retornou {get}"
# put dado
value = 5
put = client.put(unit, value, 1, 1, 1, 3, 0, 'sig')
assert put, f"PUT deveria ter retornado True, mas retornou {put}"
# get com retorno
get = client.get(unit, 1, 1, 1, 10, 0, 10, 0, 'sig')
assert get != [], f"GET deveria ter retornado algo, mas retornou {get}"
incoming = get['series'][0]['value']
assert incoming == value, f"GET deveria ter retornado algo, mas retornou {incoming}"
# put dado fora do timerange
put = client.put(0x1, 1, 1, 1, 1, 11, 1, 'sig')
assert put == False, f"PUT deveria ter retornado False, mas retornou {put}"
# TODO testar sem signature
# TODO Testar com v1.1
